/*
 *	mcga2.h -- This file is part of the MCGA Library, Vers. 2.0
 *	Copyright (C) 1992, 1993 Nils M. Holm
 */

#ifndef __LARGE__
#	error "Must compile with LARGE MODEL !"
#endif

#ifndef __MCGA2__
#	define __MCGA2__

/*	MCGA colors 0 to 15	*/
#define MBLACK		0
#define MBLUE		1
#define MGREEN		2
#define MCYAN		3
#define MRED		4
#define MMAGENTA	5
#define MBROWN		6
#define MLGREY		7
#define MGREY		8
#define MLBLUE		9
#define MLGREEN		10
#define MLCYAN		11
#define MLRED		12
#define MLMAGENTA	13
#define MYELLOW		14
#define MWHITE		15

/*	Mnemonics for the two MCGA video ram pages	*/
#define VPAGE_1		0
#define VPAGE_2		1

/*	Definition of the BitBlock structure */
typedef struct BITBLK {
	int	rows, cols, init;
	char	*stream;
} BITBLK;

/*	Prototypes ... */
extern int	initmcga(void);
extern void	endmcga(void);
extern void	mcgapixel(int x, int y, int color);
extern void	mcga_page(int page);
extern void	mcga_vpage(int page);
extern int	mcgagetpx(int x, int y);
extern void	mcgabox(int x, int y, int dx, int dy, int color);
extern void	mcgaclear(int color);
extern void	mcgahline(int x, int y, int dx, int color);
extern void	mcgavline(int x, int y, int dy, int color);
extern void	mcgaputbb(int x, int y, BITBLK *bitb);
extern void	mcgaovlbb(int x, int y, int bgrd, BITBLK *bitb);
extern void	mcgagetbb(int x, int y, BITBLK *bitb);

extern int	mcga_loadfont(char *name, int foregrd, int backgrd);
extern int	mcga_loadzfont(char *name, int foregrd, int backgrd);
extern void	mcgaputs(int x, int y, char *string);
extern void	mcgaputc(int x, int y, int chr);
extern void	mcga_textbox(int x, int y, int dx, int dy);

extern BITBLK	**mcga_load(char *name);
extern BITBLK	**mcga_zload(char *name);
extern void	mcga_unload(BITBLK **bmaps);
extern int	is_zfile(char *fname);
extern BITBLK	*mcga_mergebb(BITBLK *bb1, BITBLK *bb2, int bg);
extern BITBLK	*mcga_lrollbb(BITBLK *bb1, BITBLK *bb2, int howmany);
extern BITBLK	*mcga_rrollbb(BITBLK *bb1, BITBLK *bb2, int howmany);
extern void	mcga_destroybb(BITBLK *bb);

#endif	/* __MCGA2__ */
