#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include "mcga2.h"


BITBLK	__Cset[256];


void _nomem()
{
   endmcga();
   fprintf(stderr, "Out of memory loading font!\n");
   exit(1);
}


int mcga_loadfont(name, fg, bg)
char  *name;
int   fg, bg;
{
   FILE  *ff;
   int   max = 0, rows, cols, i;

   if ((ff = fopen(name, "rb")) == NULL)
	return(-1);

   fread(&rows, 1, sizeof(rows), ff);
   fread(&cols, 1, sizeof(cols), ff);

   while (!feof(ff)) {
	if ((__Cset[max].stream = (char *) malloc(rows*cols)) == NULL)
	   _nomem();
	__Cset[max].rows = rows;
	__Cset[max].cols = cols;
	fread(__Cset[max].stream, 1, rows*cols, ff);
	for (i=0; i<rows*cols; i++)
	   __Cset[max].stream[i] = (__Cset[max].stream[i] ? fg : bg);
	fread(&rows, 1, sizeof(rows), ff);
	fread(&cols, 1, sizeof(cols), ff);
	if (rows != __Cset[max].rows || cols != __Cset[max].cols) {
	   endmcga();
	   fprintf(stderr, "Error in font library.\n");
	   exit(1);
	}
	max++;
   }

   fclose(ff);
   return(max);
}


int mcga_loadzfont(name, f, b)
char  *name;
{
   char  oname[81];
   int   rc;

   strcpy(oname, name);
   if (strchr(oname, '.'))
	*(strchr(oname, '.')) = 0;
   strcat(oname, ".$$$");

   if (unsqueeze(name, oname) < -1) {
	unlink(oname);
	return(-1);
   }

   rc = mcga_loadfont(oname, f, b);
   unlink(oname);

   return(rc);
}


void mcgaputc(x, y, c)
int   x, y;
int   c;
{
   mcgaputbb(x++*__Cset[0].cols, y*__Cset[0].rows, &__Cset[c]);
}


void mcgaputs(x, y, s)
int   x, y;
char  *s;
{
   for (; *s; s++)
	mcgaputbb(x++*__Cset[0].cols, y*__Cset[0].rows, &__Cset[(int)*s]);
}


void mcga_textbox(x, y, dx, dy)
int  x, y, dx, dy;
{
   int  i;

   mcgaputc(x, y, 201);
   mcgaputc(x, dy, 200);
   mcgaputc(dx, y, 187);
   mcgaputc(dx, dy, 188);

   for (i=x+1; i<dx; i++) {
	mcgaputc(i, y, 205);
	mcgaputc(i, dy, 205);
   }

   for (++y; y < dy; y++) {
	mcgaputc(x, y, 186);
	mcgaputc(dx, y, 186);
	for (i=x+1; i<dx; i++)
	   mcgaputc(i, y, ' ');
   }
}
