#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "mcga2.h"
#define EXTERN
#include "events.h"
#undef EXTERN

#include "defs.h"

extern int	Sfield[15][8][5],
		Cfield[15][8][5],
		Field[15][8][5];


void gputs(x, y, s)
int	x, y;
char	*s;
{
	extern BITBLK	__Cset[];

	while (*s) {
		mcgaovlbb(x++*8, y*10, 1, &__Cset[*s++]);
	}
}


int gmenu(menu, dflt)
char	*menu;
int	dflt;
{
	char	*items[20], buf[128];
	char	*p, *q;
	int	max = 0, len = 0, l;
	int	x, y, k, i, j;

	strcpy(buf, menu);
	for (p=q=buf; *p; p++) {
		if (*p == '|') {
			items[max] = q;
			q = p+1;
			*p = 0;
			if ((l = strlen(items[max])) > len)
				len = l;
			max++;
		}
	}
	items[max] = q;
	if ((l = strlen(items[max])) > len) len = l;
	max++;

	clearbuttons();
	clearpanels();
	dfl_event = (void (*)()) 0L;

	x = 2;
	y = 10-(max/2);
	box(12, y*10-4, 18+len*8, y*10+max*10, MCYAN);
	for (i=0; i<max; i++) {
		gputs(x, y+i, items[i]);
		addbutton(28, (y+i)*10-2, 32+len*16, (y+i)*10+8, 'a'+i, 0, 0);
	}
	for (i = dflt;;) {
		box(14, (y+i)*10-2, 16+len*8, (y+i)*10+8, MMAGENTA);
 		gputs(x, y+i, items[i]);
		k = getevent();
		box(14, (y+i)*10-2, 16+len*8, (y+i)*10+8, MCYAN);
 		gputs(x, y+i, items[i]);
 		switch(k) {
 			case 'k':
 			case 328:	if (--i < 0) i = max-1; break;
 			case 'j':
 			case 336:	if (++i >= max) i = 0; break;
 			case ESC:	i = -1; goto finito;
 			case '\r':	goto finito;
 			default:	if (islower(k) && k-'a'<max) {
 						j = k-'a';
 						if (j == i) {
 							goto finito;
 						}
 						i = j;
 					}
 		}
	}

finito:
	return(i);
}


void errmsg(s)
char	*s;
{
	clearbuttons();
	clearpanels();
	box(0, 170, 319, 199, 1);
	box(14, 179, 18+strlen(s)*8, 188, MMAGENTA);
	gputs(2, 18, s);
	getevent();
}


int dbcount() {
	FILE	*f;
	int	cn;

	if ((f = fopen(BOARDDB, "rb")) == NULL) {
		return(0);
	}
	if (fread(&cn, 1, sizeof(cn), f) != sizeof(cn)) return(0);
	fclose(f);
	return(cn);
}


int dbretrieve(n) {
	FILE	*f;

	if ((f = fopen(BOARDDB, "rb")) == NULL) {
		errmsg("Cannot open database");
		return(-1);
	}
	fseek(f, n*1200L+2L, SEEK_SET);
	if (fread(Sfield, 1, sizeof(Sfield), f) != sizeof(Sfield)) {
		errmsg("Database read error");
		fclose(f);
		return(-1);
	}
	fclose(f);
	return(0);
}


int yesno() {
	return(gmenu("  Yes  |  No", 1)==0? 1: 0);
}


int leave() {
	clear();
	gputs(2, 17, "You are about to leave an unfin-");
	gputs(2, 18, "ished game. OK to Erase the board?");
	return(yesno());
}


int playboard(n) {
	extern int	Tiles_left, Usp;

	if (dbretrieve(n) < 0) return(-1);
	memcpy(Field, Sfield, sizeof(Sfield));
	Tiles_left = 144;
	Usp = 0;
	return(0);
}


void e1() {
	int	i;

	box(255, 125, 270, 145, MLMAGENTA);
	for (i=0; i<8; i++) mcgahline(266-i, 128+i, 266, MWHITE);
	for (i=7; i<15; i++) mcgahline(252+i, 128+i, 266, MWHITE);
}


void l1() {
	int	i;

	box(255, 125, 270, 145, MLCYAN);
	for (i=0; i<8; i++) mcgahline(266-i, 128+i, 266, MLBLUE);
	for (i=7; i<15; i++) mcgahline(252+i, 128+i, 266, MLBLUE);
}


void e2() {
	box(275, 125, 290, 145, MLMAGENTA);
	box(279, 129, 286, 141, MWHITE);
}


void l2() {
	box(275, 125, 290, 145, MLCYAN);
	box(279, 129, 286, 141, MLBLUE);
}


void e3() {
	int	i;

	box(295, 125, 310, 145, MLMAGENTA);
	for (i=0; i<8; i++) mcgahline(299, 128+i, 299+i, MWHITE);
	for (i=7; i<15; i++) mcgahline(299, 128+i, 313-i, MWHITE);
}


void l3() {
	int	i;

	box(295, 125, 310, 145, MLCYAN);
	for (i=0; i<8; i++) mcgahline(299, 128+i, 299+i, MLBLUE);
	for (i=7; i<15; i++) mcgahline(299, 128+i, 313-i, MLBLUE);
}


int selectboard(max) {
	int	n = 0;
	int	k;

	clear();
	clearpanels();
	clearbuttons();
	l1(); l2(); l3();

	addbutton(510, 125, 540, 145, 331, 0, 0);
	addbutton(590, 125, 620, 145, 333, 0, 0);
	addbutton(550, 125, 580, 145, '\r', 0, 0);
	addpanel(510, 125, 540, 145, e1, l1);
	addpanel(590, 125, 620, 145, e3, l3);
	addpanel(550, 125, 580, 145, e2, l2);

	for (;;) {
		if (dbretrieve(n) < 0) return(-1);
		_drawboard(Sfield);
		_left(n+1);
		k = getevent();
		switch(k) {
			case 331:
			case 328:	if (n)
						--n;
					else
						err();
					break;
			case 333:
			case 336:	if (n<max-1)
						++n;
					else
						err();
					break;
			case '\r':	if (!leave()) return(-1);
					return(playboard(n));
			case ESC:	return(-1);
		}
	}
}


char *getline(x, y, len) {
	static char	s[80];
	int		cp = 0, k;

	for (;;) {
		mcgaputc(x+cp, y, 219);
		k = getevent();
		mcgaputc(x+cp, y, ' ');
		switch(k) {
			case ESC:	return(NULL);
			case '\r':	s[cp] = 0; return(s);
			case '\b':	if (!cp) break;
					mcgaputc(x+--cp, y, ' ');
					break;
			default:	if (cp >= len || (k & 0xff00)) {
						err(); break;
					}
					mcgaputc(x+cp, y, k);
					s[cp++] = k;

		}
	}
}


int mergedb(in, add, out)
FILE	*in, *add, *out;
{
	char	s[80];
	int	inc, addc, outc = 0;
	int	i, j;

	bputs(2, 1, "Merging ...");
	if (fread(&inc, 1, sizeof(inc), in) != sizeof(inc)) return(-1);
	if (fread(&addc, 1, sizeof(addc), add) != sizeof(addc)) return(-1);
	if (fwrite(&outc, 1, sizeof(outc), out) != sizeof(outc)) return(-2);

	bputs(5, 3, "Copying database");
	for (i=0; i<inc; i++) {
		if (fread(Sfield, 1, sizeof(Sfield), in) != sizeof(Sfield))
			return(-1);
		if (fwrite(Sfield, 1, sizeof(Sfield), out) != sizeof(Sfield))
			return(-2);
		outc++;
	}

	for (i=0; i<addc; i++) {
 		sprintf(s, "Merging record: %d of %d", i+1, addc);
		bputs(5, 4, s);

		if (fread(Sfield, 1, sizeof(Sfield), add) != sizeof(Sfield))
			return(-1);

		clearerr(in);
		fseek(in, (long) sizeof(inc), SEEK_SET);

		for (j=0; j<inc; j++) {
			if (fread(Cfield, 1, sizeof(Cfield), in) !=
			sizeof(Cfield))
				return(-1);
			if (!memcmp(Sfield, Cfield, sizeof(Cfield)))
				break;
		}

		if (j >= inc) {
			if (fwrite(Sfield, 1, sizeof(Sfield), out) !=
			sizeof(Sfield))
				return(-2);
			outc++;
		}
	}

	bputs(5, 5, "Updating database");
	rewind(out);
	if (fwrite(&outc, 1, sizeof(outc), out) != sizeof(outc)) return(-2);
	return(0);
}


void merge() {
	char	*file, s[80];
	FILE	*in, *add, *out;
	char	*tmpfile = "mahjongg.ndb";
	int	ok = 0;

	clear();
	clearpanels();
	clearbuttons();
	bputs(2, 23, "Database to merge:");
	if ((file = getline(21, 23, 12)) == NULL) return;
	if ((add = fopen(file, "rb")) == NULL) {
		sprintf(s, "Cannot open: \"%s\"", file);
		errmsg(s);
		return;
	}
	if ((in = fopen(BOARDDB, "rb")) == NULL) {
		fclose(add);
		errmsg("Cannot open database");
		return;
	}
	if ((out = fopen(tmpfile, "wb")) == NULL) {
		fclose(add);
		fclose(in);
		errmsg("Cannot create merge file");
		return;
	}
	switch (mergedb(in, add, out)) {
		case -1:	errmsg("file read error"); break;
		case -2:	errmsg("file write error"); break;
		default:	ok = 1;
	}
	fclose(add);
	fclose(in);
	fclose(out);
	if (ok) {
		unlink(BOARDDB_OLD);
		rename(BOARDDB, BOARDDB_OLD);
		rename(tmpfile, BOARDDB);
	}
}


void dbmain()
{
	static dflt = 0;
	int	choice;
	int	nboard;
	char	n[6], s[100];

	nboard = dbcount();

	for (;;) {
		clear();
		if (nboard)
			sprintf(n, "%d", nboard);
		else
			strcpy(n, "no");
		sprintf(s, "There %s", nboard==1? "is": "are");
		gputs(2, 18, s);
 		sprintf(s, "won board%s.", nboard==1? "": "s");
		gputs(13+strlen(n)-(nboard==1), 18, s);
		box((96-8*(nboard==1)), 179, (96+8*strlen(n)-8*(nboard==1)),
		188, (nboard? MCYAN: MMAGENTA));
		gputs(12-(nboard==1), 18, n);

		choice = gmenu(	"Play Random Board|"
			"Select Board|"
			"Merge Databases|"
			"Return To Game"
		, dflt);

		if (choice < 0) return;

		switch (dflt = choice) {
			case 0:	if (!nboard) {
					errmsg("No boards stored yet");
					break;
				}
				if (!leave()) break;
				if (playboard(
				nboard? random(nboard): 0) < 0)
					break;
				return;
			case 1:	if (selectboard(nboard) < 0) break;
				return;
			case 2:	merge(); return;
			case 3:	return;
		}
	}
}


preferences() {
	static dflt = 0;
	int	choice;
	char	menu[128];
	extern int	SafeBoards, Allow_undo;

	clear();
	enterprefs();
	for (;;) {
		sprintf(menu, "Allow Undo (Currently %s|"
			"Generate Hard Boards (Currently %s|"
			"Return To Game", 
			Allow_undo? "ON) ": "OFF)",
			SafeBoards? "OFF)": "ON) ");
		choice = gmenu(menu, dflt);
		switch (dflt = choice) {
			case 0:	Allow_undo = !Allow_undo; break;
			case 1:	SafeBoards = !SafeBoards; break;
			case 2:	return;
		}
	}

}
